{========================================================================}
Procedure TMyApp.MsgDialog;
  Var
    B : PView;
    D : PAreaDialog;
    R : TRect;
  Begin
    If TotalAreas = 0 Then
    Begin
      Problem;
    End
    Else
    Begin
      MsgOrFile := 1;
      R.Assign(0, 0, 80, 23);
      D := New(PAreaDialog, Init(R, 'Msg Area Definition'));
      With D^ Do
      Begin
        R.Assign(2, 2, 39, 3);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(2, 1, 24, 2);
        Insert(New(PLabel, Init(R, '~M~essage Path', B)));
        R.Assign(41, 2, 78, 3);
        B := New(PInputLine, Init(R, 40));
        Insert(B);
        R.Assign(41, 1, 64, 2);
        Insert(New(PLabel, Init(R, 'M~e~ssage Name', B)));
        R.Assign(2, 4, 39, 5);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(2, 3, 24, 4);
        Insert(New(PLabel, Init(R, '~D~escription', B)));
        R.Assign(41, 4, 78, 5);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(41, 3, 64, 4);
        Insert(New(PLabel, Init(R, 'Barri~c~ade Path', B)));
        R.Assign(2, 6, 39, 7);
        B := New(PInputLine, Init(R, 62));
        Insert(B);
        R.Assign(2, 5, 24, 6);
        Insert(New(PLabel, Init(R, 'Or~i~gin', B)));
        R.Assign(41, 6, 78, 7);
        B := New(PInputLine, Init(R, 40));
        Insert(B);
        R.Assign(41, 5, 64, 6);
        Insert(New(PLabel, Init(R, '~`~Area Name', B)));
        R.Assign(41, 8, 78, 9);
        B := New(PInputLine, Init(R, 13));
        Insert(B);
        R.Assign(41, 7, 64, 8);
        Insert(New(PLabel, Init(R, '~A~lternate Menu Name', B)));
        R.Assign(2, 11, 14, 13);
        B := New(PRadioButtons, Init(R,
          NewSItem('~*~.MSG',
          NewSItem('~S~quish',
          nil))
        ));
        B^.Options := B^.Options And Not ofPostProcess;
        Insert(B);
        R.Assign(2, 10, 15, 11);
        Insert(New(PLabel, Init(R, '~T~ype', B)));
        R.Assign(22, 11, 29, 12);
        B := New(PInputLine, Init(R, 5));
        Insert(B);
        R.Assign(15, 11, 22, 12);
        Insert(New(PLabel, Init(R, 'Da~y~s', B)));
        R.Assign(22, 12, 29, 13);
        B := New(PInputLine, Init(R, 5));
        Insert(B);
        R.Assign(15, 12, 22, 13);
        Insert(New(PLabel, Init(R, 'Co~u~nt', B)));
        R.Assign(41, 11, 48, 12);
        B := New(PInputLine, Init(R, 5));
        Insert(B);
        R.Assign(30, 11, 40, 12);
        Insert(New(PLabel, Init(R, 'Ori~g~inAka', B)));
        R.Assign(55, 12, 65, 14);
        Insert(New(PButton, Init(R, 'Attri~b~', cmMsgAttrib, bfNormal)));
        R.Assign(55, 14, 65, 16);
        Insert(New(PButton, Init(R, '~S~witch', cmSwitchToFile, bfNormal)));
        R.Assign(68, 14, 78, 16);
        Insert(New(PButton, Init(R, '~L~ist', cmListAreas, bfNormal)));
        R.Assign(55, 16, 65, 18);
        Insert(New(PButton, Init(R, 'Pri~v~', cmMsgPrivButton, bfNormal)));
        R.Assign(68, 16, 78, 18);
        Insert(New(PButton, Init(R, 'Ove~r~', cmMsgOverButton, bfNormal)));
        R.Assign(55, 18, 65, 20);
        Insert(New(PButton, Init(R, '~N~ext', cmNextMsgArea, bfNormal)));
        R.Assign(68, 18, 78, 20);
        Insert(New(PButton, Init(R, '~P~rev', cmPrevMsgArea, bfNormal)));
        R.Assign(55, 20, 65, 22);
        Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
        R.Assign(68, 20, 78, 22);
        Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
        R.Assign(1, 1, 1, 1);
        Insert(New(PButton, Init(R, '~+~', cmNextMsgArea, bfNormal)));
        R.Assign(1, 1, 1, 1);
        Insert(New(PButton, Init(R, '~-~', cmPrevMsgArea, bfNormal)));
      End;
      GetAreaDialog;
      D^.SetData(MsgDialogData);
      C := DeskTop^.ExecView(D);
      If C <> cmCancel Then D^.GetData(MsgDialogData);
      If C = cmOk Then PutAreaDialog;
      Dispose(D, Done);
    End;
  End;
{========================================================================}
Procedure TMyApp.FileDialog;
  Var
    B : PView;
    D : PAreaDialog;
    R : TRect;
  Begin
    If TotalAreas = 0 Then
    Begin
      Problem;
    End
    Else
    Begin
      MsgOrFile := 2;
      R.Assign(0, 0, 80, 23);
      D := New(PAreaDialog, Init(R, 'File Area Definition'));
      With D^ Do
      Begin
        R.Assign(2, 2, 39, 3);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(2, 1, 24, 2);
        Insert(New(PLabel, Init(R, '~D~ownload Path', B)));
        R.Assign(41, 2, 78, 3);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(41, 1, 64, 2);
        Insert(New(PLabel, Init(R, '~U~pload Path', B)));
        R.Assign(2, 4, 39, 5);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(2, 3, 24, 4);
        Insert(New(PLabel, Init(R, 'Barri~c~ade Path', B)));
        R.Assign(41, 4, 78, 5);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(41, 3, 64, 4);
        Insert(New(PLabel, Init(R, 'Pa~t~h to Files.Bbs', B)));
        R.Assign(2, 6, 39, 7);
        B := New(PInputLine, Init(R, 80));
        Insert(B);
        R.Assign(2, 5, 24, 6);
        Insert(New(PLabel, Init(R, 'D~e~scription', B)));
        R.Assign(41, 6, 78, 7);
        B := New(PInputLine, Init(R, 40));
        Insert(B);
        R.Assign(41, 5, 64, 6);
        Insert(New(PLabel, Init(R, '~`~Area Name', B)));
        R.Assign(41, 8, 78, 9);
        B := New(PInputLine, Init(R, 13));
        Insert(B);
        R.Assign(41, 7, 64, 8);
        Insert(New(PLabel, Init(R, '~A~lternate Menu Name', B)));
        R.Assign(55, 14, 65, 16);
        Insert(New(PButton, Init(R, '~S~witch', cmSwitchToMsg, bfNormal)));
        R.Assign(68, 14, 78, 16);
        Insert(New(PButton, Init(R, '~L~ist', cmListAreas, bfNormal)));
        R.Assign(55, 16, 65, 18);
        Insert(New(PButton, Init(R, 'Pri~v~', cmFilePrivButton, bfNormal)));
        R.Assign(68, 16, 78, 18);
        Insert(New(PButton, Init(R, 'Ove~r~', cmFileOverButton, bfNormal)));
        R.Assign(55, 18, 65, 20);
        Insert(New(PButton, Init(R, '~N~ext', cmNextFileArea, bfNormal)));
        R.Assign(68, 18, 78, 20);
        Insert(New(PButton, Init(R, '~P~rev', cmPrevFileArea, bfNormal)));
        R.Assign(55, 20, 65, 22);
        Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
        R.Assign(68, 20, 78, 22);
        Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
        R.Assign(1, 1, 1, 1);
        Insert(New(PButton, Init(R, '~+~', cmNextFileArea, bfNormal)));
        R.Assign(1, 1, 1, 1);
        Insert(New(PButton, Init(R, '~-~', cmPrevFileArea, bfNormal)));
      End;
      GetAreaDialog;
      D^.SetData(FileDialogData);
      C := DeskTop^.ExecView(D);
      If C <> cmCancel Then D^.GetData(FileDialogData);
      If C = cmOk Then PutAreaDialog;
      Dispose(D, Done);
    End;
  End;
{========================================================================}
Procedure TAreaDialog.PrivDialog(Var Priv, Lock1, Lock2 : Word);
  Var
    B : PView;
    D : PPrivDialog;
    R : TRect;
    PrivData : PrivDialogDataType;
  Begin
    R.Assign(0, 0, 55, 15);
    R.Move(Random(26), Random(9));
    D := New(PPrivDialog, Init(R, 'Privilege Level and Keys'));
    With D^ Do
    Begin
      R.Assign(2, 2, 19, 14);
      B := New(PRadioButtons, Init(R,
        NewSItem('~H~idden',
        NewSItem('~S~ysop',
        NewSItem('~A~sstSysop',
        NewSItem('~C~lerk',
        NewSItem('~E~xtra',
        NewSItem('~F~avored',
        NewSItem('~P~rivil',
        NewSItem('~W~orthy',
        NewSItem('~N~ormal',
        NewSItem('~L~imited',
        NewSItem('~D~isgrace',
        NewSItem('~T~wit',
        nil))))))))))))
      ));
      B^.Options := B^.Options And Not ofPostProcess;
      Insert(B);
      R.Assign(2, 1, 20, 2);
      Insert(New(PLabel, Init(R, '~P~rivledge Level', B)));
      R.Assign(20, 2, 36, 10);
      B := New(PCheckBoxes, Init(R,
        NewSItem('~1~',
        NewSItem('~2~',
        NewSItem('~3~',
        NewSItem('~4~',
        NewSItem('~5~',
        NewSItem('~6~',
        NewSItem('~7~',
        NewSItem('~8~',
        NewSItem('~A~',
        NewSItem('~B~',
        NewSItem('~C~',
        NewSItem('~D~',
        NewSItem('~E~',
        NewSItem('~F~',
        NewSItem('~G~',
        NewSItem('~H~',
        nil))))))))))))))))
      ));
      B^.Options := B^.Options And Not ofPostProcess;
      Insert(B);
      R.Assign(19, 1, 36, 2);
      Insert(New(PLabel, Init(R, '--------~S~ecurity', B)));
      R.Assign(37, 2, 53, 10);
      B := New(PCheckBoxes, Init(R,
        NewSItem('~I~',
        NewSItem('~J~',
        NewSItem('~K~',
        NewSItem('~L~',
        NewSItem('~M~',
        NewSItem('~N~',
        NewSItem('~O~',
        NewSItem('~P~',
        NewSItem('~Q~',
        NewSItem('~R~',
        NewSItem('~S~',
        NewSItem('~T~',
        NewSItem('~U~',
        NewSItem('~V~',
        NewSItem('~W~',
        NewSItem('~X~',
        nil))))))))))))))))
      ));
      B^.Options := B^.Options And Not ofPostProcess;
      Insert(B);
      R.Assign(36, 1, 53, 2);
      Insert(New(PLabel, Init(R, '~K~eys------------', B)));
      R.Assign(25, 12, 35, 14);
      Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
      R.Assign(38, 12, 48, 14);
      Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
    End;
    PrivData.Priv := Priv;
    PrivData.Lock1 := Lock1;
    PrivData.Lock2 := Lock2;
    D^.SetData(PrivData);
    C := DeskTop^.ExecView(D);
    If C = cmOk Then D^.GetData(PrivData);
    Priv := PrivData.Priv;
    Lock1 := PrivData.Lock1;
    Lock2 := PrivData.Lock2;
    Dispose(D, Done);
  End;
{========================================================================}
Procedure TAreaDialog.OverDialog;
  Var
    B : PView;
    D : POverDialog;
    R : TRect;
  Begin
    R.Assign(0, 0, 54, 13);
    R.Move(Random(27), Random(11));
    D := New(POverDialog, Init(R, 'Override Command Privileges'));
    With D^ Do
    Begin
      R.Assign(2, 2, 7, 4);
      Insert(New(PButton, Init(R, '~0~', cmOver0, bfNormal)));
      R.Assign(2, 4, 7, 6);
      Insert(New(PButton, Init(R, '~1~', cmOver1, bfNormal)));
      R.Assign(2, 6, 7, 8);
      Insert(New(PButton, Init(R, '~2~', cmOver2, bfNormal)));
      R.Assign(2, 8, 7, 10);
      Insert(New(PButton, Init(R, '~3~', cmOver3, bfNormal)));
      R.Assign(15, 2, 20, 4);
      Insert(New(PButton, Init(R, '~4~', cmOver4, bfNormal)));
      R.Assign(15, 4, 20, 6);
      Insert(New(PButton, Init(R, '~5~', cmOver5, bfNormal)));
      R.Assign(15, 6, 20, 8);
      Insert(New(PButton, Init(R, '~6~', cmOver6, bfNormal)));
      R.Assign(15, 8, 20, 10);
      Insert(New(PButton, Init(R, '~7~', cmOver7, bfNormal)));
      R.Assign(28, 2, 33, 4);
      Insert(New(PButton, Init(R, '~8~', cmOver8, bfNormal)));
      R.Assign(28, 4, 33, 6);
      Insert(New(PButton, Init(R, '~9~', cmOver9, bfNormal)));
      R.Assign(28, 6, 33, 8);
      Insert(New(PButton, Init(R, '~A~', cmOverA, bfNormal)));
      R.Assign(28, 8, 33, 10);
      Insert(New(PButton, Init(R, '~B~', cmOverB, bfNormal)));
      R.Assign(41, 2, 46, 4);
      Insert(New(PButton, Init(R, '~C~', cmOverC, bfNormal)));
      R.Assign(41, 4, 46, 6);
      Insert(New(PButton, Init(R, '~D~', cmOverD, bfNormal)));
      R.Assign(41, 6, 46, 8);
      Insert(New(PButton, Init(R, '~E~', cmOverE, bfNormal)));
      R.Assign(41, 8, 46, 10);
      Insert(New(PButton, Init(R, '~F~', cmOverF, bfNormal)));
      R.Assign(28, 10, 38, 12);
      Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
      R.Assign(41, 10, 51, 12);
      Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
    End;
    C := DeskTop^.ExecView(D);
    Dispose(D, Done);
  End;
{========================================================================}
Procedure TAreaDialog.AttribDialog;
  Var
    B : PView;
    D : PAttribDialog;
    R : TRect;
  Begin
    R.Assign(0, 0, 44, 13);
    R.Move(Random(37), Random(11));
    D := New(PAttribDialog, Init(R, 'Message Privilege Attributes'));
    With D^ Do
    Begin
      R.Assign(2, 2, 15, 4);
      Insert(New(PButton, Init(R, '~H~idden   ', cmAttribH, bfNormal)));
      R.Assign(2, 4, 15, 6);
      Insert(New(PButton, Init(R, '~S~ysop    ', cmAttribS, bfNormal)));
      R.Assign(2, 6, 15, 8);
      Insert(New(PButton, Init(R, '~A~sstSysop', cmAttribA, bfNormal)));
      R.Assign(2, 8, 15, 10);
      Insert(New(PButton, Init(R, '~C~lerk    ', cmAttribC, bfNormal)));
      R.Assign(15, 2, 28, 4);
      Insert(New(PButton, Init(R, '~E~xtra    ', cmAttribE, bfNormal)));
      R.Assign(15, 4, 28, 6);
      Insert(New(PButton, Init(R, '~F~avored  ', cmAttribF, bfNormal)));
      R.Assign(15, 6, 28, 8);
      Insert(New(PButton, Init(R, '~P~rivil   ', cmAttribP, bfNormal)));
      R.Assign(15, 8, 28, 10);
      Insert(New(PButton, Init(R, '~W~orthy   ', cmAttribW, bfNormal)));
      R.Assign(28, 2, 41, 4);
      Insert(New(PButton, Init(R, '~N~ormal   ', cmAttribN, bfNormal)));
      R.Assign(28, 4, 41, 6);
      Insert(New(PButton, Init(R, '~L~imited  ', cmAttribL, bfNormal)));
      R.Assign(28, 6, 41, 8);
      Insert(New(PButton, Init(R, '~D~isgrace ', cmAttribD, bfNormal)));
      R.Assign(28, 8, 41, 10);
      Insert(New(PButton, Init(R, '~T~wit     ', cmAttribT, bfNormal)));
      R.Assign(15, 10, 28, 12);
      Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
      R.Assign(28, 10, 41, 12);
      Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
    End;
    C := DeskTop^.ExecView(D);
    Dispose(D, Done);
  End;
{========================================================================}
Procedure TOverDialog.OverPrivDialog(Var Ch : Char; Var Priv : Integer; Var Lock1, Lock2 : Word);
  Var
    B : PView;
    D : POverPrivDialog;
    R : TRect;
    PrivData : OverrideType;
  Begin
    R.Assign(0, 0, 55, 16);
    R.Move(Random(26), Random(8));
    D := New(POverPrivDialog, Init(R, 'Override Privilege Level and Keys'));
    With D^ Do
    Begin

      R.Assign(2, 2, 19, 14);
      B := New(PRadioButtons, Init(R,
        NewSItem('~H~idden',
        NewSItem('~S~ysop',
        NewSItem('~A~sstSysop',
        NewSItem('~C~lerk',
        NewSItem('~E~xtra',
        NewSItem('~F~avored',
        NewSItem('~P~rivil',
        NewSItem('~W~orthy',
        NewSItem('~N~ormal',
        NewSItem('~L~imited',
        NewSItem('~D~isgrace',
        NewSItem('~T~wit',
        nil))))))))))))
      ));
      B^.Options := B^.Options And Not ofPostProcess;
      Insert(B);
      R.Assign(2, 1, 20, 2);
      Insert(New(PLabel, Init(R, '~P~rivledge Level', B)));

      R.Assign(20, 2, 36, 10);
      B := New(PCheckBoxes, Init(R,
        NewSItem('~1~',
        NewSItem('~2~',
        NewSItem('~3~',
        NewSItem('~4~',
        NewSItem('~5~',
        NewSItem('~6~',
        NewSItem('~7~',
        NewSItem('~8~',
        NewSItem('~A~',
        NewSItem('~B~',
        NewSItem('~C~',
        NewSItem('~D~',
        NewSItem('~E~',
        NewSItem('~F~',
        NewSItem('~G~',
        NewSItem('~H~',
        nil))))))))))))))))
      ));
      B^.Options := B^.Options And Not ofPostProcess;
      Insert(B);
      R.Assign(19, 1, 36, 2);
      Insert(New(PLabel, Init(R, '--------~S~ecurity', B)));

      R.Assign(37, 2, 53, 10);
      B := New(PCheckBoxes, Init(R,
        NewSItem('~I~',
        NewSItem('~J~',
        NewSItem('~K~',
        NewSItem('~L~',
        NewSItem('~M~',
        NewSItem('~N~',
        NewSItem('~O~',
        NewSItem('~P~',
        NewSItem('~Q~',
        NewSItem('~R~',
        NewSItem('~S~',
        NewSItem('~T~',
        NewSItem('~U~',
        NewSItem('~V~',
        NewSItem('~W~',
        NewSItem('~X~',
        nil))))))))))))))))
      ));
      B^.Options := B^.Options And Not ofPostProcess;
      Insert(B);
      R.Assign(36, 1, 53, 2);
      Insert(New(PLabel, Init(R, '~K~eys------------', B)));

      R.Assign(26, 11, 29, 12);
      B := New(PInputLine, Init(R, 1));
      Insert(B);
      R.Assign(29, 11, 47, 12);
      Insert(New(PLabel, Init(R, '~L~etter of Command', B)));

      R.Assign(25, 13, 35, 15);
      Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
      R.Assign(38, 13, 48, 15);
      Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
    End;
    PrivData.Ch := Ch;
    PrivData.Priv := Priv;
    PrivData.Lock1 := Lock1;
    PrivData.Lock2 := Lock2;
    D^.SetData(PrivData);
    C := DeskTop^.ExecView(D);
    If C = cmOk Then D^.GetData(PrivData);
    Ch := PrivData.Ch[1];
    Priv := PrivData.Priv;
    Lock1 := PrivData.Lock1;
    Lock2 := PrivData.Lock2;
    Dispose(D, Done);
  End;
{========================================================================}
Procedure TAttribDialog.OverPrivDialog(Var Attrib : Word);
  Var
    B : PView;
    D : PAttribPrivDialog;
    R : TRect;
    AttribData : AttribRecType;
  Begin
    R.Assign(0, 0, 25, 22);
    R.Move(Random(56), Random(2));
    D := New(PAttribPrivDialog, Init(R, 'Attributes'));
    With D^ Do
    Begin
      R.Assign(2, 2, 23, 18);
      B := New(PCheckBoxes, Init(R,
        NewSItem('~0~ Matrix',
        NewSItem('1',
        NewSItem('~2~ No Public',
        NewSItem('~3~ No Private',
        NewSItem('~4~ Anonymous Ok',
        NewSItem('~5~ EchoMail',
        NewSItem('~6~ High Bit',
        NewSItem('7',
        NewSItem('8',
        NewSItem('~9~ No ^aRealName',
        NewSItem('~A~ Use RealName',
        NewSItem('~B~ Conference',
        NewSItem('~C~ Alias',
        NewSItem('D',
        NewSItem('E',
        NewSItem('F',
        nil))))))))))))))))
      ));
      Insert(B);
      R.Assign(2, 19, 12, 21);
      Insert(New(PButton, Init(R, '~O~k', cmOK, bfDefault)));
      R.Assign(13, 19, 23, 21);
      Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));
    End;
    AttribData.Attrib := Attrib;
    D^.SetData(AttribData);
    C := DeskTop^.ExecView(D);
    If C = cmOk Then D^.GetData(AttribData);
    Attrib := AttribData.Attrib;
    Dispose(D, Done);
  End;
{========================================================================}
Procedure TMyApp.About;
  Var
    D : PDialog;
    B : PView;
    R : TRect;
  Begin
    R.Assign(0, 0, 54, 9);
    D := New(PDialog, Init(R, 'About'));
    With D^ Do
    Begin
      Options := Options Or ofCentered;
      R.Grow(-1, -1);
      Dec(R.B.Y, 3);
      Insert(New(PStaticText, Init(R,#13+^C'Maximus Area Manager'#13+^C+Pgmid)));
      R.Assign(22, 6, 32, 8);
      Insert(New(PButton, Init(R, 'O~K', cmOk, bfDefault)));
    End;
    C := Desktop^.ExecView(D);
    Dispose(D, Done);
  End;
{========================================================================}
Procedure TMyApp.Problem;
  Var
    D : PDialog;
    B : PView;
    R : TRect;
  Begin
    R.Assign(0, 0, 54, 9);
    D := New(PDialog, Init(R, 'Trouble in Paradise'));
    With D^ Do
    Begin
      Options := Options Or ofCentered;
      R.Grow(-1, -1);
      Dec(R.B.Y, 3);
      Insert(New(PStaticText, Init(R,#13
        +^C'One of the following has probably occured:'#13
        +^C+AreaPath+' does not exist or'#13
        +^C'there are no valid areas!')));
      R.Assign(22, 6, 32, 8);
      Insert(New(PButton, Init(R, 'O~K', cmOk, bfDefault)));
    End;
    C := Desktop^.ExecView(D);
    Dispose(D, Done);
  End;
{========================================================================}
