{========================================================================}
Procedure GetAreaDialog;
  Begin
    Result := GetMaxArea(AreaNumber);
    With MsgDialogData Do
    Begin
      MsgPath := Array2String(@MaxAreaRecord^.MsgPath);
      MsgName := Array2String(@MaxAreaRecord^.MsgName);
      MsgInfo := Array2String(@MaxAreaRecord^.MsgInfo);
      MsgBar := Array2String(@MaxAreaRecord^.MsgBar);
      Origin := Array2String(@MaxAreaRecord^.Origin);
      AreaName := Array2String(@MaxAreaRecord^.Name);
      MsgMenuName := Array2String(@MaxAreaRecord^.MsgMenuName);
      AreaType := MaxAreaRecord^.AreaType-1;
      Str(MaxAreaRecord^.KillByAge:5,KillByAge);
      Str(MaxAreaRecord^.KillByNum:5,KillByNum);
      Str(MaxAreaRecord^.OriginAka:5,OriginAka);
    End;
    With MsgPrivData Do
    Begin
      Priv := MaxToRadio(MaxAreaRecord^.MsgPriv);
      Lock1 := MaxAreaRecord^.MsgLock1;
      Lock2 := MaxAreaRecord^.MsgLock2;
    End;
    For Gbx := 1 To MaxClass Do Attrib[Gbx] := MaxAreaRecord^.Attrib[Gbx];
    For Gbx := 1 To MaxOvr Do
    Begin
      Over[1,Gbx].Priv := MaxToRadio(MaxAreaRecord^.MOvr[Gbx].Priv);
      Over[1,Gbx].Lock1 := MaxAreaRecord^.MOvr[Gbx].Lock1;
      Over[1,Gbx].Lock2 := MaxAreaRecord^.MOvr[Gbx].Lock2;
      Over[1,Gbx].Ch := MaxAreaRecord^.MOvr[Gbx].Ch;
      Over[2,Gbx].Priv := MaxToRadio(MaxAreaRecord^.FOvr[Gbx].Priv);
      Over[2,Gbx].Lock1 := MaxAreaRecord^.FOvr[Gbx].Lock1;
      Over[2,Gbx].Lock2 := MaxAreaRecord^.FOvr[Gbx].Lock2;
      Over[2,Gbx].Ch := MaxAreaRecord^.FOvr[Gbx].Ch;
    End;
    With FileDialogData Do
    Begin
      DownLoad := Array2String(@MaxAreaRecord^.FilePath);
      UpLoad := Array2String(@MaxAreaRecord^.UpPath);
      Barricade := Array2String(@MaxAreaRecord^.FileBar);
      FilesBbs := Array2String(@MaxAreaRecord^.FilesBbs);
      FileInfo := Array2String(@MaxAreaRecord^.FileInfo);
      AreaName := Array2String(@MaxAreaRecord^.Name);
      FileMenuName := Array2String(@MaxAreaRecord^.FileMenuName);
    End;
    With FilePrivData Do
    Begin
      Priv := MaxToRadio(MaxAreaRecord^.FilePriv);
      Lock1 := MaxAreaRecord^.FileLock1;
      Lock2 := MaxAreaRecord^.FileLock2;
    End;
    For Gix := 0 To StructLen-1 Do
    Begin
      Bp1 := Ptr(Seg(CompareBuffer^),Ofs(CompareBuffer^)+Gix);
      Bp2 := Ptr(Seg(RecordBuffer^),Ofs(RecordBuffer^)+Gix);
      Bp1^ := Bp2^;
    End;
  End;
{========================================================================}
Function SaveIt : Boolean;
  Var
    B : PView;
    D : PDialog;
    R : TRect;
  Begin
    R.Assign(5, 5, 30, 10);
    D := New(PDialog, Init(R, 'Save Data'));
    With D^ Do
    Begin
      R.Assign(2, 2, 12, 4);
      Insert(New(PButton, Init(R, '~Y~es', cmYes, bfDefault)));
      R.Assign(13, 2, 23, 4);
      Insert(New(PButton, Init(R, '~N~o', cmNo, bfNormal)));
    End;
    C := DeskTop^.ExecView(D);
    Dispose(D, Done);
    Case C Of
      cmYes : SaveIt := True;
      cmNo : SaveIt := False;
    End;
    C := cmOk;
  End;
{========================================================================}
Function DataChanged : Boolean;
  Var
    TempBoolean : Boolean;
  Begin
    TempBoolean := False;
    For Gix := 0 To StructLen-1 Do
    Begin
      Bp1 := Ptr(Seg(CompareBuffer^),Ofs(CompareBuffer^)+Gix);
      Bp2 := Ptr(Seg(RecordBuffer^),Ofs(RecordBuffer^)+Gix);
      If Bp1^ <> Bp2^ Then TempBoolean := True;
    End;
    DataChanged := TempBoolean;
  End;
{========================================================================}
Procedure PutAreaDialog;
  Begin
    With MsgDialogData Do
    Begin
      String2Array(@MaxAreaRecord^.MsgPath,MsgPath,80);
      String2Array(@MaxAreaRecord^.MsgName,MsgName,40);
      String2Array(@MaxAreaRecord^.MsgInfo,MsgInfo,80);
      String2Array(@MaxAreaRecord^.MsgBar,MsgBar,80);
      String2Array(@MaxAreaRecord^.Origin,Origin,62);
      If MsgOrFile = 1 Then String2Array(@MaxAreaRecord^.Name,AreaName,40);
      String2Array(@MaxAreaRecord^.MsgMenuName,MsgMenuName,13);
      MaxAreaRecord^.AreaType := AreaType+1;
      Val(KillByAge,MaxAreaRecord^.KillByAge,Result);
      Val(KillByNum,MaxAreaRecord^.KillByNum,Result);
      Val(OriginAka,MaxAreaRecord^.OriginAka,Result);
    End;
    With MsgPrivData Do
    Begin
      MaxAreaRecord^.MsgPriv := RadioToMax(Priv);
      MaxAreaRecord^.MsgLock1 := Lock1;
      MaxAreaRecord^.MsgLock2 := Lock2;
    End;
    For Gbx := 1 To MaxClass Do MaxAreaRecord^.Attrib[Gbx] := Attrib[Gbx];
    For Gbx := 1 To MaxOvr Do
    Begin
      MaxAreaRecord^.MOvr[Gbx].Priv := RadioToMax(Over[1,Gbx].Priv);
      MaxAreaRecord^.MOvr[Gbx].Lock1 := Over[1,Gbx].Lock1;
      MaxAreaRecord^.MOvr[Gbx].Lock2 := Over[1,Gbx].Lock2;
      MaxAreaRecord^.MOvr[Gbx].Ch := Over[1,Gbx].Ch;
      MaxAreaRecord^.FOvr[Gbx].Priv := RadioToMax(Over[2,Gbx].Priv);
      MaxAreaRecord^.FOvr[Gbx].Lock1 := Over[2,Gbx].Lock1;
      MaxAreaRecord^.FOvr[Gbx].Lock2 := Over[2,Gbx].Lock2;
      MaxAreaRecord^.FOvr[Gbx].Ch := Over[2,Gbx].Ch;
    End;
    With FileDialogData Do
    Begin
      String2Array(@MaxAreaRecord^.FilePath,DownLoad,80);
      String2Array(@MaxAreaRecord^.UpPath,UpLoad,80);
      String2Array(@MaxAreaRecord^.FileBar,Barricade,80);
      String2Array(@MaxAreaRecord^.FilesBbs,FilesBbs,80);
      String2Array(@MaxAreaRecord^.FileInfo,FileInfo,80);
      If MsgOrFile = 2 Then String2Array(@MaxAreaRecord^.Name,AreaName,40);
      String2Array(@MaxAreaRecord^.FileMenuName,FileMenuName,13);
    End;
    With FilePrivData Do
    Begin
      MaxAreaRecord^.FilePriv := RadioToMax(Priv);
      MaxAreaRecord^.FileLock1 := Lock1;
      MaxAreaRecord^.FileLock2 := Lock2;
    End;
    If DataChanged Then
    Begin
      If SaveIt Then
      Begin
        Result := PutMaxArea(AreaNumber);
        Assign(AreaNdx,D+'Area.Ndx');
        Reset(AreaNdx);
        Seek(AreaNdx,AreaNumber-1);
        Read(AreaNdx,NdxRecord);
        Case MsgOrFile Of
          1 : String2Array(@NdxRecord.Name,MsgDialogData.AreaName,Max_Alen);
          2 : String2Array(@NdxRecord.Name,FileDialogData.AreaName,Max_Alen);
        End;
        Seek(AreaNdx,AreaNumber-1);
        Write(AreaNdx,NdxRecord);
        Close(AreaNdx);
      End;
    End;
  End;
{========================================================================}
