{========================================================================}
Constructor TMyApp.Init;
  Begin
    TApplication.Init;
    Fsplit(Fexpand(ParamStr(0)),D,N,E);
    AreaPath := D+'AREA.DAT';
    AreaNumber := 1;
    If OpenMaxArea Then
    Begin
      MaxAreaRecord := RecordBuffer;
      LoadAreaNames;
      GetMem(CompareBuffer,StructLen);
      About;
    End;
    If (Not AreaDatOpen) Or (TotalAreas = 0) Then Problem;
  End;
{========================================================================}
Procedure TMyApp.InitMenuBar;
  Var
    R : TRect;
  Begin
    GetExtent(R);
    R.B.Y := R.A.Y + 1;
    MenuBar := New(PMenuBar, Init(R, NewMenu(
      NewSubMenu('~'#240'~', hcNoContext, NewMenu(
        NewItem('~A~bout', '', kbNoKey, cmAbout, hcNoContext,
        Nil)),
      NewSubMenu('~A~rea', hcNoContext, NewMenu(
        NewItem('~M~sg Definition', 'F2', kbF2, cmMsgDialog, hcNoContext,
        NewItem('~F~ile Definition', 'F3', kbF3, cmFileDialog, hcNoContext,
        NewItem('~L~ist Areas', 'F4', kbF4, cmListAreas, hcNoContext,
        Nil)))),
    Nil)))));
  End;
{========================================================================}
Procedure TMyApp.InitStatusLine;
  Var
    R : TRect;
  Begin
    GetExtent(R);
    R.A.Y := R.B.Y - 1;
    StatusLine := New(PStatusLine, Init(R,
      NewStatusDef(0, $FFFF,
        NewStatusKey('', kbF10, cmMenu,
        NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
        NewStatusKey('~F2~ Msg Area', kbF2, cmMsgDialog,
        NewStatusKey('~F3~ File Area', kbF3, cmFileDialog,
        NewStatusKey('~F4~ List Areas', kbF4, cmListAreas,
        NewStatusKey('~Alt-F3~ Close', kbAltF3, cmClose,
        NIL)))))),
      NIL)
    ));
  End;
{========================================================================}
Destructor TMyApp.Done;
  Begin
    TApplication.Done;
    If AreaDatOpen Then
    Begin
      CloseMaxArea;
      FreeMem(CompareBuffer,StructLen);
    End;
  End;
{========================================================================}
