{========================================================================}
Procedure LoadAreaNames;
  Var
    NameTemp : String;
  Begin
    AreaColRec.AreaCol := New(PCollection, Init(25, 5));
    For AreaNumber := 1 To TotalAreas Do
    Begin
      Result := GetMaxArea(AreaNumber);
      NameTemp := Copy(Array2String(@MaxAreaRecord^.Name)+'       ',1,8)+' '
      +Copy(Array2String(@MaxAreaRecord^.MsgInfo)+'                         ',1,25)+' '
      +Array2String(@MaxAreaRecord^.FileInfo);
      If NameTemp = '' Then NameTemp := ' ';
      AreaColRec.AreaCol^.Insert(NewStr(NameTemp));
    End;
    AreaNumber := 1;
  End;
{========================================================================}
Procedure TMyApp.ListAreas;
  Var
    R : TRect;
    SB : PScrollBar;
  Begin
    If TotalAreas = 0 Then
    Begin
      Problem;
    End
    Else
    Begin
      R.Assign(0, 0, 75, 20);
      AreasDialog := New(PAreasList, Init(R, 'Select Area'));
      With AreasDialog^ Do
      Begin
        Options := Options Or ofCentered;
        R.Assign(66, 3, 67, 18);
        SB := New(PScrollBar, Init(R));
        Insert(SB);
        R.Assign(3, 3, 66, 18);
        AreasBox := New(PListBox, Init(R, 1, SB));
        AreasBox^.Options := AreasBox^.Options Or ofFramed;
        Insert(AreasBox);
        R.Assign(3, 2, 9, 3);
        Insert(New(PLabel, Init(R, 'Area', AreasBox)));
        R.Assign(12, 2, 33, 3);
        Insert(New(PLabel, Init(R, 'Message Description', AreasBox)));
        R.Assign(38, 2, 56, 3);
        Insert(New(PLabel, Init(R, 'File Description', AreasBox)));
        R.Assign(67, 4, 73, 6);
        Insert(New(PButton, Init(R, '~M~', cmSwitchToMsg, bfNormal)));
        R.Assign(67, 6, 73, 8);
        Insert(New(PButton, Init(R, '~F~', cmSwitchToFile, bfNormal)));
        R.Assign(67, 8, 73, 10);
        Insert(New(PButton, Init(R, '~O~K', cmOk, bfDefault)));
        SelectNext(False);
      End;
      AreaColRec.Item := AreaNumber-1;
      AreasDialog^.SetData(AreaColRec);
      C := Desktop^.ExecView(AreasDialog);
      AreasDialog^.GetData(AreaColRec);
      Dispose(AreasDialog, Done);
      AreaNumber := AreaColRec.Item+1;
    End;
  End;
{========================================================================}
Procedure TAreaDialog.ListAreas;
  Var
    R : TRect;
    SB : PScrollBar;
  Begin
    R.Assign(0, 0, 75, 20);
    Case MsgOrFile Of
      1 : AreasDialog := New(PAreasList, Init(R, 'Select Message Area'));
      2 : AreasDialog := New(PAreasList, Init(R, 'Select File Area'));
    End;
    With AreasDialog^ Do
    Begin
      Options := Options Or ofCentered;
      R.Assign(66, 3, 67, 18);
      SB := New(PScrollBar, Init(R));
      Insert(SB);
      R.Assign(3, 3, 66, 18);
      AreasBox := New(PListBox, Init(R, 1, SB));
      AreasBox^.Options := AreasBox^.Options Or ofFramed;
      Insert(AreasBox);
      R.Assign(3, 2, 9, 3);
      Insert(New(PLabel, Init(R, 'Area', AreasBox)));
      Case MsgOrFile Of
        1 :
        Begin
          R.Assign(12, 2, 33, 3);
          Insert(New(PLabel, Init(R, '~MESSAGE~ Description', AreasBox)));
          R.Assign(38, 2, 56, 3);
          Insert(New(PLabel, Init(R, 'File Description', AreasBox)));
        End;
        2 :
        Begin
          R.Assign(12, 2, 33, 3);
          Insert(New(PLabel, Init(R, 'Message Description', AreasBox)));
          R.Assign(38, 2, 56, 3);
          Insert(New(PLabel, Init(R, '~FILE~ Description', AreasBox)));
        End;
      End;
{     R.Assign(67, 4, 73, 6);
      Insert(New(PButton, Init(R, '~M~', cmSwitchToMsg, bfNormal)));
      R.Assign(67, 6, 73, 8);
      Insert(New(PButton, Init(R, '~F~', cmSwitchToFile, bfNormal)));   }
      R.Assign(67, 8, 73, 10);
      Insert(New(PButton, Init(R, '~O~K', cmOk, bfDefault)));
      SelectNext(False);
    End;
    AreaColRec.Item := AreaNumber-1;
    AreasDialog^.SetData(AreaColRec);
    C := Desktop^.ExecView(AreasDialog);
    AreasDialog^.GetData(AreaColRec);
    Dispose(AreasDialog, Done);
    AreaNumber := AreaColRec.Item+1;
  End;
{========================================================================}
